function [fls] = auto_line_id(fls)
for energy_nr = 1:length(fls.fluolines)
    fls.fluolines(energy_nr).id = get_line_id(fls, fls.fluolines(energy_nr).energy);
end

for energy_nr = 1:length(fls.fluolines)
    fls.fluolines(energy_nr).id = check_line_id(fls, energy_nr);
    close(fsp);
end

export_line_ids(fls);

    function [line_id] = check_line_id(fls, energy_nr)
        fsp = figure(4001);
        clf
        fls.exp.spectrum = sum(sum(fls.exp.data, 2), 3);
        
        if ~isempty(fls.calib.energies)
            semilogy(fls.calib.energies, fls.exp.spectrum)
            xlabel('Energy, [keV]')
        end
        
        title(['Check auto peak indentification.'])
        hold on
        energy_1 = fls.fluolines(energy_nr).energy - fls.fluolines(energy_nr).bandwidth / 2;
        energy_2 = fls.fluolines(energy_nr).energy + fls.fluolines(energy_nr).bandwidth / 2;
        index_start = find_energy_index(fls.calib.energies, min([energy_1 energy_2]));
        index_stop = find_energy_index(fls.calib.energies, max([energy_1 energy_2]));
        H=area(fls.calib.energies(index_start:index_stop), fls.exp.spectrum(index_start:index_stop));
        set(H(1),'FaceColor','r');
        alpha(.3);
        max_index = index_start + find(fls.exp.spectrum(index_start:index_stop) == ...
                                       max(fls.exp.spectrum(index_start:index_stop)), 1) - 1;
        value_string = sprintf('%s', fls.fluolines(energy_nr).id);
        text(fls.calib.energies(max_index), fls.exp.spectrum(max_index)+1e6, value_string);
        hold off
        got_answer = 0;
        while got_answer == 0
            answer = input('is the line ID correct?(Y/n)\n','s');
            if strcmp(answer, 'Yes') || strcmp(answer, 'Y') || strcmp(answer, 'y') || ...
                      strcmp(answer, 'yes') || strcmp(answer, '')
                  line_id = fls.fluolines(energy_nr).id;
                  got_answer = 1;
            elseif strcmp(answer, 'No') || strcmp(answer, 'N') || ...
                   strcmp(answer, 'n') || strcmp(answer, 'no')
                line_id=input('Please identify the peak\n','s');
                got_answer = 1;
            else
                fprintf('I do not understand this answer. Try again.\n');
                got_answer = 0;
            end
        end
    end
        
    function index = find_energy_index(spectrum_points, energy)
        index = find(abs(spectrum_points - energy) == ...
            min(abs(spectrum_points - energy)), 1) - 1;
    end

    function [line_id] = get_line_id(fls, energy)
        lines = [fls.xraydb.reduced_lines];
        energies = [lines.energy];

        index = find(abs(energies - energy) < min(abs(energies - energy))+fls.calib.resolution, 3);
        sub_lines = lines(index);
        intensity_index = find([sub_lines.intensity] == max([sub_lines.intensity]));
        line_id = sprintf('%s %s %2.2fkeV', sub_lines(intensity_index).element, ...
                                            sub_lines(intensity_index).line, ...
                                            sub_lines(intensity_index).energy);
    end
end