function [color, fields] = load_color_scheme(name, show_color_scheme)
if nargin < 2
    show_color_scheme = 0;
end

if isequal(name, 'bright')
    color.neutral = [245 232 208];
    color.red = [224 80 76];
    color.blue = [155 183 205];
    color.green = [132 169 140];
    color.yellow = [252 252 98];
    color.orange = [254 209 140];
    color.grey1 = [76 91 92];
    color.grey2 = [27 32 33];
    color.grey3 = [115 130 144];

elseif isequal(name, 'cblind')
    %color.black = [0 0 0];
    color.orange = [230 159 0];
    color.skyblue = [86 180 233];
    color.bluegreen = [0 158 115];
    color.yellow = [240 228 66];
    color.blue = [0 114 178];
    color.vermilion = [213 94 0];
    color.redpurple = [204 121 167];
    
elseif isequal(name, 'mute')
    color.neutral = [230 237 242];
    color.red = [192 87 70];
    color.blue = [115 146 183];
    color.green = [173 198 152];
    color.yellow = [243 222 138];
    color.orange = [254 215 102];
    color.grey1 = [76 84 84];
    color.grey2 = [27 32 33];
    color.grey3 = [115 130 144];
    
elseif isequal(name, 'poly')
    color.neutral = [244 233 212];
    color.red1 = [224 80 76];
    color.red2 = [237 28 36];
    color.blue1 = [148 196 214];
    color.blue2 = [80 133 182];
    color.green = [173 198 152];
else
    disp('ERROR: not implemented color scheme')
end

fields = fieldnames(color);
for fn=fields'
    color.(fn{1}) = color.(fn{1}) / 255;
end

if show_color_scheme == 1
    square = ones(40,40);
    figure
    i = 1;
    for fn=fields'
        subplot(3,3,i)
        imshow(square, color.(fn{1}))
        i = i + 1;
    end
end

end