function [fls] = reduce_xraydb(fls)
    cutoff_energies = [min(fls.calib.energies) max(fls.calib.energies)];
    
    min_energy = cutoff_energies(1);
    max_energy = cutoff_energies(2);
    
    indices = [fls.xraydb.edges.energy] - min_energy >= 0;
    edges = fls.xraydb.edges(indices);
    indices = [edges.energy] - max_energy <= 0;
    edges = edges(indices);
    
    indices = [fls.xraydb.lines.energy] - min_energy >= 0;
    lines = fls.xraydb.lines(indices);
    indices = [lines.energy] - max_energy <= 0;
    lines = lines(indices);
    
    reduced_lines = [];
    prev_element = edges(1).element;
    indices = [lines.element] == edges(1).element;
    temp_lines = lines(indices);
    if ~isempty(temp_lines)
        sub_indices = [temp_lines.initial_level] == edges(1).edge;
        reduced_lines = [reduced_lines; temp_lines(sub_indices)];
    end
    
    for i=2:length(edges)
        if edges(i).element == prev_element
           if ~isempty(temp_lines)
                sub_indices = [temp_lines.initial_level] == edges(i).edge;
                reduced_lines = [reduced_lines; temp_lines(sub_indices)];
           end
        elseif edges(i).element ~= prev_element
           prev_element = string(edges(i).element);
           indices = [lines.element] == edges(i).element;
           temp_lines = lines(indices);
           if ~isempty(temp_lines)
                sub_indices = [temp_lines.initial_level] == edges(i).edge;
                reduced_lines = [reduced_lines; temp_lines(sub_indices)];
           end
        end
    end
    
    fls.xraydb.reduced_edges = edges;
    fls.xraydb.reduced_lines = reduced_lines;
end