
%return
clear all
close all
%% Prepare processing template
fls = prepare_template();

%% Load fluorescence data
fls = load_fluo(fls);

%% Load X-ray database
% not online
fls = load_xrdb(fls);

%% Interactively select spectral range
% not online
plot_spectrum(fls);
fls = get_spectral_range(fls);

%% Interactively estimate spectrum for specific elements
% not online
cutoff_energies = [0 12];
elements = {'Mn', 'Co', 'Zn', 'Ni'};
estimate_spectrum(cutoff_energies, elements)

%% Lines identification
% not online
fls = manual_line_id(fls);
fls = auto_line_id(fls);

%% Show individual fuorescent maps
show_individual_fluo_maps(fls);

%% Show pseudo-color fluorescent maps

%% Estimate resolution using power spectrum method
% not online
fls = compute_power_spectrum_res(fls);
plot_power_spectrum_res(fls);

%% Get probe from ptycho scan and perform probe deconvolution
% partially online, probe loads only once for online

%% Estimate resolution using FSC method

%% Filter unresolved features
% must be boolean in the template preparation

%% Save reconstructed data

%% Prepare viewer template
