#!/usr/bin/env python
#*-----------------------------------------------------------------------*
#|                                                                       |
#|  Copyright (c) 2014 by Paul Scherrer Institute (http://www.psi.ch)    |
#|                                                                       |
#|              Author Thierry Zamofing (thierry.zamofing@psi.ch)        |
#*-----------------------------------------------------------------------*
'''
Sample Code, that can be executed by the RESTServer as new child process
'''
import sys,logging,time
import utilities as ut

_log=logging.getLogger(__name__)

def LogOut(s):
  log=logging.root.handlers[0].stream
  log.write(s)
  log.flush()

class DummyChildProcess:

  def Run(self,args):
    try:
      pipe=args.pipe
    except AttributeError:
      pipe=None
    idx=0
    while True:
      if pipe and pipe.poll():
        cmd=pipe.recv()
        if cmd=='stop':
          break
        elif cmd=='frmCnt':
          pipe.send(str(idx))
      time.sleep(.5)
      LogOut('.')
      sys.stdout.write('*')
      idx+=1
    if pipe: pipe.send(str(idx)) #send the frame numbers to the pipe

def RunWithArgs(args):
  if type(args)==dict:
    args=ut.dotdict(args)
    if not args.has_key('verbose'):
      args['verbose']=1
    _log.setLevel(logging.INFO if args.verbose&1 else logging.WARNING)

  print _log,logging.root,logging.root.handlers
  print 'stream',logging.root.handlers[0].stream
  print 'printing to stdout',__name__,args
  print >> sys.stderr, 'printing to stderr',__name__,args
  _log.info(args)
  _log.debug('debug')
  _log.info('info')
  _log.warning('warning')
  _log.error('error')

  dcp=DummyChildProcess()
  dcp.Run(args)

if __name__ == '__main__':
  args=ut.dotdict({'verbose':1})
  ut.LogConfig(args, {__name__     : -1, 'utilities'  : -1,})
  RunWithArgs(args)

