#!/bin/bash
#1                               +––––––––––––+
#                        hdf5    |            |   hdf5
#                       +––––––->| procMoment +–––--->
#                                |            |
#                                +––––––––––––+
#
#2                               +––––––––––––+             +–––––––––––+
#                        hdf5    |            |    8081     |           |
#                      +––––––-->| procMoment +–––––––––––+>| zmqWriter |
#                                |            |             |           |
#                                +––––––––––––+             +–––––––––––+
#
#3 +-----------+                 +––––––––––––+
#  |           |   8080          |            |   hdf5
#  | zmqImgSrc +––––––––––––––-->| procMoment +–––--->
#  |           |                 |            |
#  +-----------+                 +––––––––––––+
#
#4 +-----------+                 +––––––––––––+             +–––––––––––+
#  |           |   8080          |            |    8081     |           |
#  | zmqImgSrc +––––––––––––––-->| procMoment +–––––––––––+>| zmqWriter |
#  |           |                 |            |             |           |
#  +-----------+                 +––––––––––––+             +–––––––––––+
#
source configTest.sh

#ARGS='-m -v3'
#ARGS='-v259'
ARGS='-v259 -m'
#ARGS='-v771 -m'
ARGS='-v323 -m'
#ARGS='-v263'
#ARGS='-m -v263' #1 and 2 runs smooth, 3 4 blocks because end unknown
#ARGS='-m0 -v263' #1 and 2 runs smooth, 3 4 blocks because end unknown
#ARGS='-v3'

SRCHDF=$INDIR/cSAXS_2013_10_e14608_georgiadis_3D_for_Marianne/scan_00106.hdf5
#SRCHDF=$INDIR/cSAXS_2013_10_e14608_georgiadis_3D_for_Marianne/scan_00106-00161.hdf5
SRCELEM=/entry/data/pilatus_1
MSK=$INDIR/cSAXS_2013_10_e14608_georgiadis_3D_for_Marianne/analysis/data/pilatus_valid_mask.mat
DSTELEM=entry/data/moments

RunTest()
{
case "$1" in
1) #1 hdf -> hdf
#$LXR/procMoment.py --src hdf $SRCHDF $SRCELEM --procmode c -v$V
$LXR/procMoment.py --src hdf $SRCHDF $SRCELEM --procmode c --dst hdf $OUTDIR/procMoment1.hdf5 $DSTELEM --matMsk $MSK $ARGS
;;
2) #2 hdf -> zmq
$XT0 "$LXR/zmqWriter.py --addr tcp://*:8081 --dst hdf $OUTDIR/procMoment2.hdf5 $DSTELEM --timeout 5000 -v --qs 100;$ENDCMD"&
$LXR/procMoment.py --src hdf $SRCHDF $SRCELEM --procmode c --dst zmq addr:tcp://localhost:8081 qs:4 if:PUSH timeout:5000 --matMsk $MSK $ARGS
;;
3) #3 zmq -> hdf
$XT0 "$LXR/zmqImageSource.py -v --addr=tcp://*:8080 --src hdf $SRCHDF $SRCELEM -s;$ENDCMD"&
$LXR/procMoment.py --src zmq addr:tcp://localhost:8080 qs:4 if:PULL timeout:5000 --procmode c --dst hdf $OUTDIR/procMoment3.hdf5 $DSTELEM --matMsk $MSK $ARGS
;;
4) #4 zmq -> zmq
$XT0 "$LXR/zmqImageSource.py -v --addr tcp://*:8080 --src hdf $SRCHDF $SRCELEM -s;$ENDCMD"&
$XT1 "$LXR/zmqWriter.py --addr tcp://*:8081 --dst hdf $OUTDIR/procMoment4.hdf5 $DSTELEM --timeout 50000 -v;$ENDCMD"&
$LXR/procMoment.py --src zmq addr:tcp://localhost:8080 qs:4 if:PULL timeout:5000 --procmode c --dst zmq addr:tcp://localhost:8081 qs:4 if:PUSH timeout:5000 --matMsk $MSK $ARGS
;;
*) # ------- bug ---------
echo "Unknown parameters"
;;
esac
}

for idx in $*; do
  echo RunTest $idx
  RunTest $idx
  WaitAll
  if [ -z $NO_UI ]; then
    $LXR/procMoment.py show $OUTDIR/procMoment$idx.hdf5 $DSTELEM 66
  fi
done
#ls -l $OUTDIR/procMoment*

