#!/bin/bash
source /home/zamofing_t/Documents/prj/libDetXR/python/libDetXR/test/configTest.sh
mkdir -p $OUTDIR
rm $OUTDIR/procPtychoOut*.hdf5
rm $OUTDIR/ptycho*.hdf5
ls -l $OUTDIR/ptycho*.hdf5

NO_COLOR='\x1b[0m'
OK_COLOR='\x1b[32;01m'
ERROR_COLOR='\x1b[31;01m'
WARN_COLOR='\x1b[33;01m'


export MKL_LIBRARY_PATH=/afs/psi.ch/sys/linux/opt/intel/intel-14.0.2.x86_64/composer_xe_2013_sp1.2.144/mkl/lib/intel64
export HDF5_LIBRARY_PATH=/home/zamofing_t/Documents/prj/WorkBench/hdf5/lib
export ANADIR=/scratch/detectorData/cSAXS_sxdm_2014_07_omny_commissioning/analysis/S00033

cd /home/zamofing_t/Documents/prj/PtychoSrc/src

shopt -s expand_aliases # use aliases in non interactive script
alias ptycho_fix="LD_LIBRARY_PATH=$MKL_LIBRARY_PATH:$HDF5_LIBRARY_PATH OMP_NUM_THREADS=10 ./ptycho --feedback_interval=1 --verbose=1 --diffmap_iterations 5 --max_mlh_iterations=5"
alias ptycho="LD_LIBRARY_PATH=$MKL_LIBRARY_PATH:$HDF5_LIBRARY_PATH OMP_NUM_THREADS=10 ./ptycho --feedback_interval=1 --verbose=1"
alias ptychoShow="python ../tst/display_solution.py"

echo -e $WARN_COLOR 'ptycho S00033_data_400x400.h5 S00033_initial_conditions_400x400.h5 >> ptychoOut0.hdf5' $NO_COLOR
ptycho_fix $ANADIR/S00033_data_400x400.h5 $ANADIR/S00033_initial_conditions_400x400.h5 $OUTDIR/ptychoOut0.hdf5
ptychoShow $ANADIR/S00033_initial_conditions_400x400.h5
ptychoShow $OUTDIR/ptychoOut0.hdf5

DSTELEM=entry/data/out
SRCHDF=/scratch/detectorData/cSAXS_sxdm_2014_07_omny_commissioning/eiger/S00000-00999/S00033/e15285_1_00033_00000_00000.h5
SRCELEM=eh5/images

echo -e $WARN_COLOR 'procPtycho ptycho.json oldHdfStruct >> ptychoIn1.hdf5 ptychoInit1.hdf5' $NO_COLOR
sed -e s"|\$OUTDIR|$OUTDIR|" -e s"|\$INDIR|$INDIR|" -e s"|procPtycho1|ptychoIn1|" -e s"|initPtycho1|ptychoInit1|" $LXR/test/ptycho1.json > /tmp/ptycho.json
$LXR/procPtycho.py --meta /tmp/ptycho.json --cmpr s-zlib4 --multiproc --oldHdfStruct
echo -e $WARN_COLOR 'ptycho ptychoIn2.hdf5 ptychoInit2.hdf5 >> ptychoOut2.hdf5' $NO_COLOR
ptycho $OUTDIR/ptychoIn1.hdf5 $OUTDIR/ptychoInit1.hdf5 $OUTDIR/ptychoOut1.hdf5
ptychoShow $OUTDIR/ptychoInit1.hdf5
ptychoShow $OUTDIR/ptychoOut1.hdf5
#--> try with data=np.rot90(data) comment out in procPtycho results as expected BULLSHIT

#test with new format
echo -e $WARN_COLOR 'procPtycho ptycho.json oldHdfStruct >> ptychoIn2.hdf5 ptychoInit2.hdf5' $NO_COLOR
sed -e s"|\$OUTDIR|$OUTDIR|" -e s"|\$INDIR|$INDIR|" -e s"|procPtycho1|ptychoIn2|" -e s"|initPtycho1|ptychoInit2|" $LXR/test/ptycho1.json > /tmp/ptycho.json
$LXR/procPtycho.py --meta /tmp/ptycho.json --cmpr s-zlib4 --multiproc
echo -e $WARN_COLOR 'ptycho ptychoIn2.hdf5 ptychoInit2.hdf5 >> ptychoOut2.hdf5' $NO_COLOR
ptycho $OUTDIR/ptychoIn2.hdf5 $OUTDIR/ptychoInit2.hdf5 $OUTDIR/ptychoOut2.hdf5
ptychoShow $OUTDIR/ptychoInit2.hdf5
ptychoShow $OUTDIR/ptychoOut2.hdf5

ls -l $OUTDIR/ptycho*.hdf5

