#!/bin/bash
#1                               +––––––––––––+
#                        hdf5    |            |   hdf5
#                       +––––––->| procSTXM   +–––--->
#                                |            |
#                                +––––––––––––+
#
#2                               +––––––––––––+             +–––––––––––+
#                        hdf5    |            |    8081     |           |
#                      +––––––-->| procSTXM   +–––––––––––+>| zmqWriter |
#                                |            |             |           |
#                                +––––––––––––+             +–––––––––––+
#
#3 +-----------+                 +––––––––––––+
#  |           |   8080          |            |   hdf5
#  | zmqImgSrc +––––––––––––––-->| procSTXM   +–––--->
#  |           |                 |            |
#  +-----------+                 +––––––––––––+
#
#4 +-----------+                 +––––––––––––+             +–––––––––––+
#  |           |   8080          |            |    8081     |           |
#  | zmqImgSrc +––––––––––––––-->| procSTXM   +–––––––––––+>| zmqWriter |
#  |           |                 |            |             |           |
#  +-----------+                 +––––––––––––+             +–––––––––––+
#
source configTest.sh

ARGS='-v259 -m'

SRCHDF=$INDIR/stxm_pinhole/scan_00158-00198.hdf5
SRCELEM=/entry/data/pilatus_1
PARAM='--roiSize 0 20'
#SRCHDF=$INDIR/stxm_fren_zone_plate/scan_06825-07075.hdf5
#SRCELEM=/entry/data/pilatus
#PARAM='--roiSize 0 70'
DSTELEM=entry/data/STXM

RunTest()
{
case "$1" in
1) #1 hdf -> hdf
#$LXR/procSTXM.py --src hdf $SRCHDF $SRCELEM $PARAM -v$V
#$LXR/procSTXM.py --src hdf $SRCHDF $SRCELEM  --size 66 56 -v$V
$LXR/procSTXM.py --src hdf $SRCHDF $SRCELEM $PARAM --dst hdf $OUTDIR/procSTXM1.hdf5 $DSTELEM $ARGS
;;
2) #2 hdf -> zmq
$XT0 "$LXR/zmqWriter.py --addr tcp://*:8081 --dst hdf $OUTDIR/procSTXM2.hdf5 $DSTELEM --timeout 5000000 -v;$ENDCMD"&
$LXR/procSTXM.py --src hdf $SRCHDF $SRCELEM $PARAM --dst zmq addr:tcp://localhost:8081 qs:4 if:PUSH timeout:5000 $ARGS
;;
3) #3 zmq -> hdf
$XT0 "$LXR/zmqImageSource.py -v --addr=tcp://*:8080 --src hdf $SRCHDF $SRCELEM -s;$ENDCMD"&
$LXR/procSTXM.py --src zmq addr:tcp://localhost:8080 qs:4 if:PULL timeout:5000  $PARAM --dst hdf $OUTDIR/procSTXM3.hdf5 $DSTELEM $ARGS
;;
4) #4 zmq -> zmq
$XT0 "$LXR/zmqImageSource.py -v --addr tcp://*:8080 --src hdf $SRCHDF $SRCELEM -s;$ENDCMD"&
$XT1 "$LXR/zmqWriter.py --addr tcp://*:8081 --dst hdf $OUTDIR/procSTXM4.hdf5 $DSTELEM --timeout 5000 -v;$ENDCMD"&
$LXR/procSTXM.py --src zmq addr:tcp://localhost:8080 qs:4 if:PULL timeout:5000  $PARAM --dst zmq addr:tcp://localhost:8081 qs:4 if:PUSH timeout:5000 $ARGS
;;
*) # ------- bug ---------
echo "Unknown parameters"
;;
esac
}

for idx in $*; do
  echo RunTest $idx
  RunTest $idx
  WaitAll
  if [ -z $NO_UI ]; then
    $LXR/procSTXM.py show $OUTDIR/procSTXM$idx.hdf5 $DSTELEM 41
  fi
done

#ls -l $OUTDIR/procSTXM*

