#!/bin/bash
source configTest.sh

echo 'measure idle load...'
mpstat -P ALL 1 5 | grep Average

mpstat -P ALL 1 > $OUTDIR/mpstat1.log&
PIDStat=$!

NUM=32
#NUM=256
#$LXR/testPerfCmprHdf5Write.py --src cbf $INDIR/TestCBF/ --num $NUM cmpSpeed&
#$LXR/testPerfCmprHdf5Write.py --src cbf $INDIR/TestCBF/ --num $NUM cmpSpeed --cmpr lz4 lzf zlib246
$LXR/testPerfCmprHdf5Write.py --src cbf $INDIR/TestCBF/ --num $NUM cmpSpeed --cmpr lz4 lzf zlib246 --shuffle
#$LXR/testPerfCmprHdf5Write.py --src cbf $INDIR/TestCBF/ --num $NUM cmpSpeed --cmpr lz4 lzf zlib246 --shuffle --diff
kill $PIDStat

mpstat -P ALL 1 > $OUTDIR/mpstat2.log&
PIDStat=$!
NUM=256
#$LXR/testPerfCmprHdf5Write.py --src cbf $INDIR/TestCBF/ --num $NUM wrHDF --cmpr s-zlib4 --dst $OUTDIR/testPerf.hdf5  --multiproc MPI Pipe1 Pipe1b Pipe2 Pipe2b Pool1 Pool1b ShMem1 ShMem2 ShMem1b
$LXR/testPerfCmprHdf5Write.py --src cbf $INDIR/TestCBF/ --num $NUM wrHDF --cmpr s-zlib4 --dst $OUTDIR/testPerf.hdf5  --multiproc Pipe1b ShMem2
kill $PIDStat


#Pool1b:  Raw: 2418.48MB Compr:162.89MB Ratio: 93.26%, 14.85x Speed: 77.51MB/s
#Pool1b:  Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed: 77.37MB/s
#MPI:     Raw: 4836.96MB Compr:323.23MB Ratio: 93.32%, 14.96x Speed:125.82MB/s
#MPI:     Raw: 2418.48MB Compr:160.35MB Ratio: 93.37%, 15.08x Speed:127.36MB/s
#Pipe2:   Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed:148.65MB/s
#Pipe2:   Raw: 2418.48MB Compr:162.89MB Ratio: 93.26%, 14.85x Speed:160.01MB/s
#Pool1:   Raw: 2418.48MB Compr:162.89MB Ratio: 93.26%, 14.85x Speed:162.91MB/s
#Pool1:   Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed:164.47MB/s
#Pipe2b:  Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed:169.41MB/s
#Pipe2b:  Raw: 2418.48MB Compr:162.89MB Ratio: 93.26%, 14.85x Speed:190.27MB/s
#Pipe1:   Raw: 2418.48MB Compr:162.89MB Ratio: 93.26%, 14.85x Speed:197.84MB/s
#Pipe1:   Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed:198.48MB/s
#ShMem1:  Raw: 2418.48MB Compr:162.89MB Ratio: 93.26%, 14.85x Speed:206.10MB/s
#ShMem1:  Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed:208.79MB/s
#ShMem1b: Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed:208.59MB/s
#Pipe1b:  Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed:215.02MB/s  <<<
#Pipe1b:  Raw: 2418.48MB Compr:162.89MB Ratio: 93.26%, 14.85x Speed:218.25MB/s  <<<
#ShMem1b: Raw: 2418.48MB Compr:162.89MB Ratio: 93.26%, 14.85x Speed:218.27MB/s
#ShMem2:  Raw: 2418.48MB Compr:162.89MB Ratio: 93.26%, 14.85x Speed:232.02MB/s  <<<
#ShMem2:  Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed:233.77MB/s  <<<

#ShMem1b: Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed:201.67MB/s
#ShMem1:  Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed:205.21MB/s
#Pipe1b:  Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed:211.50MB/s
#ShMem2:  Raw: 4836.96MB Compr:325.77MB Ratio: 93.26%, 14.85x Speed:228.60MB/s




