#!/usr/bin/env python

# *-----------------------------------------------------------------------*
# |                                                                       |
# |  Copyright (c) 2013 by Paul Scherrer Institute (http://www.psi.ch)    |
# |                                                                       |
# |              Author Thierry Zamofing (thierry.zamofing@psi.ch)        |
# *-----------------------------------------------------------------------*
'''
generate filenames with a given filename pattern.
'''

import logging
_log=logging.getLogger(__name__)
if __name__ == '__main__':
  logging.basicConfig(level=logging.DEBUG,format='%(levelname)s:%(module)s:%(lineno)d:%(funcName)s:%(message)s ')
  pass

class FileNameGen:
  def Generate(self):
    pass
  def GetFileName(self,  mode=0,  idx=0, dbg=0):
    '''moves the cunnent pointer to a specified location
       mode 0: BEGIN
       mode 1: RELATIVE
       mode 2: END
    '''
    maxPos=reduce(lambda x, y: x * y, self.varLen) #maxPos=prod(self.varLen)
    if mode==0:
      self.curPos=idx
    elif mode==1:
      self.curPos+=idx
    else:
      self.curPos=maxPos-idx
    d=maxPos
    r=self.curPos
    if r<0 or r>=maxPos:
      raise IndexError('out of range')
    dct=dict()
    dct['idx']=r
    for n in range(len(self.varName)):
      d/=self.varLen[n]
      (q, r)=divmod(r, d)
      try:
        dct[self.varName[n]]=self.varRange[n][q]
      except TypeError as e:
        dct[self.varName[n]]=q
    _log.debug((self.curPos, dct))
    s=eval(self.expr,dct)
    res=self.ptrn%s
    return res

  @staticmethod
  def GetVarLen(a):
    try:
      return len(a)
    except TypeError as e:
      return a

  def SetPatternVarRange(self,ptrn, expr,  varNameRange):
    '''Set the substitution pattern
       assuming a variable X and Y substitution is done
       Set the substitution variables and ranges
       Reserved names are:
       idx: the current index

       Example:
       ptrn='../path%2d_%2d/fileName%0d_%0d'
       expr='Z,round(idx/100),Y,X'
       var=(('X',range(5)),('Y',range(10,16),('Z',range(3))
    '''
    self.ptrn=ptrn
    self.expr='('+expr+')'
    self.varName,self.varRange =zip(*varNameRange) #unzip the list
    self.varLen=map(FileNameGen.GetVarLen,self.varRange)
    self.curPos=0

if __name__ == '__main__':
  def Test1():
    """Testing CbfFileNameGen"""
    fng=FileNameGen()
    fng.SetPatternVarRange('../path%.2d/fileName%.5d_%.5d.cbf',
    'Z,Y,X',(('X',5),('Y',6),('Z',3)))
    #for p in range(90):
    #  print fng.GetFileName(0, p)

    fng.SetPatternVarRange('../path_%s-%.2d_%.2d/fileName%.5d_%.5d.cbf',
    'Z,round(idx/10)*10,round(idx/10)*10+9,Y,X',(('X',5),('Y',range(10,16)),('Z',('AA', 'BB', 'CC'))))
    for p in range(90):
      print fng.GetFileName(0, p)
    pass

#---------- MAIN TEST CODE ----------
  logging.getLogger(__name__).setLevel(logging.WARN)
  Test1() #Testing FileNameGen

