#!/usr/bin/env python
#*-----------------------------------------------------------------------*
#|                                                                       |
#|  Copyright (c) 2013 by Paul Scherrer Institute (http://www.psi.ch)    |
#|                                                                       |
#|              Author Thierry Zamofing (thierry.zamofing@psi.ch)        |
#*-----------------------------------------------------------------------*
'''
implements an test functions to process stxm of a hdf5 dataset.
'''

import sys, os, glob, stat
import h5py
sys.path.insert(0, os.path.abspath('../'))
import utilities as ut

def GetGlob(inGlob,ext):
  'returns a sorted list of files in a directory'
  #for recursive searching see:
  #http://stackoverflow.com/questions/14798220/how-can-i-search-sub-folders-using-glob-glob-module-in-python
  fnLst=[]
  if type(inGlob)==str: inGlob=(inGlob,)
  for glb in inGlob:
    glb=os.path.expanduser(glb)
    try:
      s=os.stat(glb)
      if stat.S_ISDIR(s.st_mode):
        glb=os.path.join(glb,'*.'+ext)
    except OSError: pass
    else: pass
    fnLst.extend(glob.iglob(glb))
  fnLst.sort()
  return fnLst

def ListObj(fn,gid):
  grp=h5py.Group(gid)
  #print grp.name
  for k,v in grp.iteritems():
    t=type(v.id)
    if t==h5py.h5g.GroupID:
      ListObj(fn,v.id)
    elif t==h5py.h5d.DatasetID:
      print str((fn,str(v.name),v.shape))+','
      pass

if __name__ == '__main__':
  import os,sys,argparse #since python 2.7

  def Run():
    #ifeq ($(shell hostname),pc9477)
    if len(sys.argv)>1:
      OUTDIR=sys.argv[1]
    else:
      OUTDIR='/scratch/tmp/libDetXRTest'
    print 'checking result in directory',OUTDIR
    lst=(
('OutCon0', '/entry/data/dataset', (100, 216, 256)),
('OutCon1', '/entry/data/dataset', (100, 216, 256)),
('OutCon2', '/entry/data/dataset', (100, 216, 256)),
('OutCon3', '/entry/data/dataset', (100, 216, 256)),
('OutCon4', '/entry/data/dataset', (100, 216, 256)),
('OutCon5', '/entry/data/dataset', (100, 216, 256)),
('OutCon60', '/entry/data/dataset', (66, 1679, 1475)),
('OutCon61', '/entry/data/out', (66, 6)),
('OutCon62', '/entry/data/out', (66, 16, 1203)),
('OutCon63', '/entry/data/out', (66, 3)),
('OutCon64', '/detector/0/bad_pixels', (118, 2)),
('OutCon64', '/detector/0/modules', (1, 4)),
('OutCon64', '/measurement/0/data', (66, 400, 400)),
('OutCon64', '/measurement/0/positions', (200, 2)),
('RESTSvr20', '/entry/data/dataset', (66, 1679, 1475)),
('RESTSvr21', '/entry/data/out', (66, 6)),
('RESTSvr22', '/entry/data/out', (66, 16, 1203)),
('RESTSvr23', '/entry/data/out', (66, 3)),
('RESTSvr24', '/detector/0/bad_pixels', (118, 2)),
('RESTSvr24', '/detector/0/modules', (1, 4)),
('RESTSvr24', '/measurement/0/data', (66, 400, 400)),
('RESTSvr24', '/measurement/0/positions', (200, 2)),
('initPtycho1', '/objects/object_0', (863, 874)),
('initPtycho1', '/probes/probe_0', (400, 400)),
('procMoment1', '/entry/data/moments', (66, 6)),
('procMoment2', '/entry/data/moments', (66, 6)),
('procMoment3', '/entry/data/moments', (66, 6)),
('procMoment4', '/entry/data/moments', (66, 6)),
('procPtycho1', '/detector/0/bad_pixels', (118, 2)),
('procPtycho1', '/detector/0/modules', (1, 4)),
('procPtycho1', '/measurement/0/data', (200, 400, 400)),
('procPtycho1', '/measurement/0/positions', (200, 2)),
('procPtycho2', '/entry/data/out', (200, 400, 400)),
('procPtycho3', '/detector/0/bad_pixels', (118, 2)),
('procPtycho3', '/detector/0/modules', (1, 4)),
('procPtycho3', '/measurement/0/data', (200, 400, 400)),
('procPtycho3', '/measurement/0/positions', (200, 2)),
('procPtycho4', '/entry/data/out', (200, 400, 400)),
('procRoiStat1', '/entry/data/roiStat', (66, 16, 1203)),
('procRoiStat2', '/entry/data/roiStat', (66, 16, 1203)),
('procRoiStat3', '/entry/data/roiStat', (66, 16, 1203)),
('procRoiStat4', '/entry/data/roiStat', (66, 16, 1203)),
('procSTXM1', '/entry/data/STXM', (1681, 3)),
('procSTXM2', '/entry/data/STXM', (1681, 3)),
('procSTXM3', '/entry/data/STXM', (1681, 3)),
('procSTXM4', '/entry/data/STXM', (1681, 3)),
('zmqWriter16', '/entry/data/dataset', (100, 216, 256)),
('zmqWriter16cmp', '/entry/data/dataset', (100, 216, 256)),
('zmqWriter16cmpmp', '/entry/data/dataset', (100, 216, 256)),
('zmqWriter2Stream1', '/entry/data/dataset/AqE', (100, 216, 256)),
('zmqWriter2Stream1', '/entry/data/dataset/BrQ', (100, 480, 640)),
('zmqWriter2Stream2', '/entry/data/dataset/BrQ', (100, 480, 640)),
('zmqWriter2Stream2', '/entry/data/dataset/the/Path/OF_AqE', (100, 216, 256)),
('zmqWriter32', '/entry/data/dataset', (100, 216, 256)),
('zmqWriter32cmp', '/entry/data/dataset', (100, 216, 256)),
('zmqWriter32cmpmp', '/entry/data/dataset', (100, 216, 256)),
('zmqWriter4', '/entry/data/dataset', (100, 216, 256)),
('zmqWriter4cmp', '/entry/data/dataset', (100, 216, 256)),
('zmqWriter4cmpmp', '/entry/data/dataset', (100, 216, 256)),
('zmqWriter8', '/entry/data/dataset', (100, 216, 256)),
('zmqWriter8cmp', '/entry/data/dataset', (100, 216, 256)),
('zmqWriter8cmpmp', '/entry/data/dataset', (100, 216, 256)),
('zmqWriterOfsDim1', '/entry/data/dataset', (5, 32, 16, 8)),
('zmqWriterOfsDim2', '/entry/data/dataset', (5, 32, 16, 8)),
('zmqWriterOfsDim3', '/entry/data/dataset', (5, 32, 16, 8)),
('testPerf', '/entry/data/NewDataset', (256, 1679, 1475)),
        )


    fnLst=GetGlob(OUTDIR,'hdf5')
    fnLst=[os.path.splitext(os.path.basename(fn))[0] for fn in fnLst]
    #fnLst=set(fnLst)
    print '---- hdf5 files: dataset shape tests warnings ---'
    for (fn,ds,sh) in lst:
      try: fnLst.remove(fn)
      except ValueError:pass
      try:
        fid=ut.OpenFile(os.path.join(OUTDIR,fn)+'.hdf5', 'r')
      except IOError:
        print 'missing file:',fn,ds,sh
        continue
      grp=h5py.Group(fid)
      try:
        if grp[ds].shape!=sh:
          print 'failed shape:',fn,ds,sh,'!=',grp[ds].shape
      except KeyError:
          print 'missing dataset:',fn,ds,sh
      ut.CloseFile(fid)

    print '---- not tested hdf5 files: list contents ---'
    for fn in fnLst:
      try:
        fid=ut.OpenFile(os.path.join(OUTDIR,fn)+'.hdf5', 'r')
        ListObj(fn,fid)
        ut.CloseFile(fid)
      except IOError:
        print 'wrong hdf5 file:',fn


#------------------ Main Code ----------------------------------
  Run()
