#!/bin/bash

#  +-----------+                 +-----------+
#  |           |   8080          |           |
#  | zmqImgSrc |+--------------->| zmqWriter |
#  |           |                 |           |
#  +-----------+                 +-----------+
#                                       ^
#                                       |
#                                       +----------+
#                                                  |
#  +-----------+                 +-----------+     |
#  |           |   8081          |           |     |
#  | zmqImgSrc |+--------------->| zmqWriter |     |
#  |           |                 |           |     |
#  +-----------+                 +-----------+     |
#                                       ^          |
#                                       |          |
#                                       +----------+
#                                       |
#                                       +
#                                  REST 8090

#multiple(2) smq2hdf5 started to write to multiple(2) output hdf5-files: /scratch/detectorData/testREST0.hdf5
#                                                                        /scratch/detectorData/testREST1.hdf5
source configTest.sh
if [ `hostname` == "pc9477" ]; then
  HOSTSRC=`hostname`
  HOSTDST=`hostname`
  CURLCMD=
else
  HOSTSRC=`hostname`
  HOSTDST=xbl-daq-20
  CURLCMD=$CURLCMD',"user":"'$USER'"'
fi

echo "starting zmqImageSource0"
xterm -geometry 180x15+0+27 -T zmqImageSource0 -e "$LXR/zmqImageSource.py --src raw uint16 2560 2160 /scratch/detectorData/PCO/ -v -s -i --addr=tcp://*:8080 -v ;sleep 1d"&
PIDzmqImageSource0=$!
echo "PIDzmqImageSource0 $PIDzmqImageSource0"

echo "starting zmqImageSource1"
xterm -geometry 180x15+0+262 -T zmqImageSource1 -e "$LXR/zmqImageSource.py --src inc uint16 2560 2160 6 -v -s -i --addr=tcp://*:8081 -v ;sleep 1d"&
PIDzmqImageSource1=$!
echo "PIDzmqImageSource1 $PIDzmqImageSource1"

echo "starting restServer"
xterm -geometry 180x15+0+497 -T restServer -e "$LXR/zmqWriter.py rest --port=8090 -v;sleep 1d"&
PIDrestServer=$!
echo "PIDrestServer $PIDrestServer"
WaitRESTServer http://localhost:8090

echo "sending configurations to restServer"

#configure zmqWriter writers:
curl -i -X PUT http://localhost:8090/cam0/config -d '{"dst":["hdf","'$OUTDIR/zmqWr2RST_1.hdf5'","entry/data/dataset"], "addr": "tcp://localhost:8080"}'
curl -i -X PUT http://localhost:8090/cam1/config -d '{"dst":["hdf","'$OUTDIR/zmqWr2RST_2.hdf5'","entry/data/dataset"], "addr": "tcp://localhost:8081"}'
curl -i -X GET http://localhost:8090/all
curl -i -X GET http://localhost:8090/info

if [ -z $NO_UI ]; then
  echo "check page http://localhost:8090/ in firefox"
  firefox http://localhost:8090/
fi

echo ">>>run/stop the existing instances 'cam0,cam1'<<<"
curl -i -X PUT http://localhost:8090/cam0/run
curl -i -X PUT http://localhost:8090/cam1/run
echo "wait a few seconds before stopping file writing..."
sleep 10
echo "stop file writing..."
curl -i -X PUT http://localhost:8090/cam0/stop
curl -i -X PUT http://localhost:8090/cam1/stop

ls -l $OUTDIR/zmqWr2RST*

if [ -z $NO_UI ]; then
  WaitAll
else
  kill $PIDzmqImageSource0 $PIDzmqImageSource1 $PIDrestServer
fi

